unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin,ShellAPI;

type
  TForm3 = class(TForm)
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    SpinEdit3: TSpinEdit;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    SpinEdit4: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  dnums           :array of array[1..3] of integer;
  drills          :array of Array[1..2] of integer;

  comp_hide_ref,
  comp_hide_comment,
  comp_locked,

  ref_des_x,
  ref_des_y,
  ref_des_height,
  ref_des_width,
  ref_des_direction,
  ref_des_layer,

  comment_x,
  comment_y,
  comment_height,
  comment_width,
  comment_direction,
  comment_layer :Integer;

  ref_des_str,
  pattern_str,
  Comment_str     :String;

  next_dnum,
  x1,x2,y1,y2,
  layer,cheight,
  cwidth,linewidth,
  diameter,
  holesize,
  padnum,
  plane,
  shape,
  rotation,
  fillx,filly,
  segments        :Integer;
  ofilename,
  ctext           :String;
  ifile, ofile    :TEXT;
  Form6Called     :Boolean;
  procedure reset_data;


  implementation

uses Unit1, Unit6;

{$R *.DFM}
function getbin(LocS :string; var LocX:Integer):integer;
var
tempstr  :String;
x,z      :Integer;
begin
  While (Is_sep(LocS[LocX])=True) do LocX:=LocX+1;
  While (Is_sep(LocS[LocX])=False)do
  begin
     tempstr:=tempstr+LocS[LocX];
     LocX:=LocX+1;
  end;
  val(Tempstr,x,z);
  getbin:=x;
end;
{----------------------------------------------}
procedure add_apt(lashape:integer;
                  lawidth:Integer;
                  laheight:Integer);
var
x                 :Integer;
allready          :Boolean;
begin
   allready:=False;
   if (next_dnum>10) then
      begin
         x:=10;
         while(x<next_dnum) do
            begin
               if (
                   (dnums[x][1]=lashape)AND
                   (dnums[x][2]=lawidth)AND
                   (dnums[x][3]=laheight)
                   )then allready:=True;
            x:=x+1;
            end;
      end;
   if (allready=False) then
      begin
         SetLength(dnums,next_dnum+1);
         dnums[next_dnum][1]:=lashape;
         dnums[next_dnum][2]:=lawidth;
         dnums[next_dnum][3]:=laheight;
         next_dnum:=next_dnum+1;
      end;
end;
{----------------------------------------------}
procedure reset_data;
begin
x1:=-1;
x2:=-1;
y1:=-1;
y2:=-1;
layer:=-1;
cheight:=-1;
cwidth:=-1;
linewidth:=-1;
diameter:=-1;
holesize:=-1;
padnum:=-1;
plane:=-1;
shape:=-1;
rotation:=-1;
fillx:=-1;
filly:=-1;
segments:=-1;
ctext:='';
end;
{----------------------------------------------}
procedure GetFill(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1    :=getbin(LocS, x);
  y1    :=getbin(LocS, x);
  x2    :=getbin(LocS, x);
  y2    :=getbin(LocS, x);
  layer :=getbin(LocS, x);
  fillx:=abs(x1-x2);
  filly:=abs(y1-y2);
end;
{---------------------------------------------------}
procedure GetTrack(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1        :=getbin(LocS, x);
  y1        :=getbin(LocS, x);
  x2        :=getbin(LocS, x);
  y2        :=getbin(LocS, x);
  linewidth :=getbin(LocS, x);
  layer     :=getbin(LocS, x);
  shape     :=-1;
  if(x1 < Unit6.PCB_Min_X) then Unit6.PCB_Min_X := x1;
  if(x2 < Unit6.PCB_Min_X) then Unit6.PCB_Min_X := x2;
  if(x1 > Unit6.PCB_Max_X) then Unit6.PCB_Max_X := x1;
  if(x2 > Unit6.PCB_Max_X) then Unit6.PCB_Max_X := x1;
  if(y1 < Unit6.PCB_Min_Y) then Unit6.PCB_Min_Y := y1;
  if(y2 < Unit6.PCB_Min_Y) then Unit6.PCB_Min_Y := y2;
  if(y1 > Unit6.PCB_Max_Y) then Unit6.PCB_Max_Y := y1;
  if(y2 > Unit6.PCB_Max_Y) then Unit6.PCB_Max_Y := y1;

end;
{---------------------------------------------------}
procedure GetVia(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1      :=getbin(LocS, x);
  y1      :=getbin(LocS, x);
  diameter:=getbin(LocS, x);
  holesize:=getbin(LocS, x);
end;
{---------------------------------------------------}
procedure GetPad(LocS:String);
var
x         :Integer;
tempstr   :String;
begin
  x:=1;
  x1      :=getbin(LocS, x);
  y1      :=getbin(LocS, x);
  cwidth   :=getbin(LocS, x);
  cheight  :=getbin(LocS, x);
  shape   :=getbin(LocS, x);
  holesize:=getbin(LocS, x);
  plane   :=getbin(LocS, x);
  layer   :=getbin(LocS, x);
  readln(ifile,tempstr);
  val(tempstr,padnum,x);
  // plane definitions : 1 = none
  //                     2 = relief to ground
  //                     3 = direct to ground
  //                     4 = relief to power
  //                     5 = direct to power
end;
{---------------------------------------------------}
procedure GetArc(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1       :=getbin(LocS, x);
  y1       :=getbin(LocS, x);
  diameter :=getbin(LocS, x);
  segments :=getbin(LocS, x);
  linewidth:=getbin(LocS, x);
  layer    :=getbin(LocS, x);
  shape    :=-1;
end;
{---------------------------------------------------}
procedure GetString(LocS:String);
var
x         :Integer;
begin
  x:=1;
  x1       :=getbin(LocS, x);
  y1       :=getbin(LocS, x);
  cheight   :=getbin(LocS, x);
  rotation :=getbin(LocS, x);
  linewidth:=getbin(LocS, x);
  layer   :=getbin(LocS, x);
  readln(ifile,ctext);
end;
{---------------------------------------------------}
procedure GetComponent(var iFile :Textfile);
var
x         :Integer;
locs      :String;
begin

   readln(iFile,ref_des_str);   // get ref des
   readln(iFile,pattern_str);   // get pattern
   readln(iFile,Comment_str);   // get comment
// need to make sure we have the appropriate apertures for these strings

   readln(iFile,locs);   // get comment information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   comment_x :=getbin(locs, x);
   comment_y :=getbin(locs, x);
   comment_height :=getbin(locs, x);
   comment_direction :=getbin(locs, x);
   comment_width :=getbin(locs, x);
   comment_layer :=getbin(locs, x);

   readln(iFile,locs);   // get ref des information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   ref_des_x :=getbin(locs, x);
   ref_des_y :=getbin(locs, x);
   ref_des_height :=getbin(locs, x);
   ref_des_direction :=getbin(locs, x);
   ref_des_width :=getbin(locs, x);
   ref_des_layer :=getbin(locs, x);

   readln(iFile,locs);   // get component information
   locs:=trim(locs);
   locs:=locs+' ';
   x:=1;
   comp_hide_ref :=getbin(locs, x);
   comp_hide_ref :=getbin(locs, x);
   comp_hide_ref :=getbin(locs, x);
   comp_hide_comment :=getbin(locs, x);
   comp_locked :=getbin(locs, x);

end;

{---------------------------------------------------}
procedure TForm3.Button1Click(Sender: TObject);
var
NewData    :Boolean;
x,y,z     :Integer;
tempstr,
locs,
inbuf     :String;
mode      :Char;
continue,
new_data  :Boolean;
begin
SetLength(drills,0);           // erase any exsiting drill data
SetLength(dnums,0);           // erase any exsiting drill data
Form1.opendialog1.filterindex:=1;
Form1.opendialog1.filename:='';
if form1.opendialog1.execute=true then
   begin
     inbuf:=Form1.opendialog1.filename;
     Unit6.PCB_File_Name := Form1.opendialog1.filename;
         if (NOT(FileExists(inbuf))) then
           begin
              showmessage('Invalid file name!');
              exit;
          end;
    Tempstr:='';
     x1:=1;
     while inbuf[x1]<>'.' do
     begin
        TempStr:=TempStr+inbuf[x1];
        x1:=x1+1;
     end;
     Unit6.BASE_File_Name:=TempStr;
     TempStr:=TempStr+'.APT';
     ofilename:=TempStr;     {save output file name}
     Unit6.APT_File_Name:=TempStr;
     continue:=True;
     If (FileExists(ofilename)=True) then
        begin
        inbuf:='File '+ofilename+' exisits!  Replace this file?';
        if MessageDlg(inbuf, mtConfirmation,[mbYes, mbNo], 0) = mrNo then Continue:=False;
        end;
     if (continue=True) then
     begin
      AssignFile(ifile,Form1.opendialog1.filename);
      reset(ifile);
      AssignFile(ofile,ofilename);
      rewrite(ofile);
      SetLength(dnums,10);
      next_dnum:=10;
      add_apt(1,3,3);             {add apts for drill dwg}
      add_apt(1,5,5);             {0.005 d11}
      add_apt(1,1,1);             {0.001  d12}
      while(not EOF(ifile)) do
         begin
            readln(ifile,inbuf);
            reset_data;
            new_data:=True;
            if ((inbuf='CP')OR(inbuf='FP')) then
               begin
                  mode:='P';
                  readln(ifile,inbuf);
                  GetPad(inbuf+' ');
               end
            else if ((inbuf='CA')OR(inbuf='FA')) then
               begin
                  mode:='A';
                  readln(ifile,inbuf);
                  GetArc(inbuf+' ');
                  add_apt(1,linewidth,linewidth);
                  mode:='i';
                  New_Data:=False;
               end
            else if ((inbuf='CT')OR(inbuf='FT')) then
               begin
                  mode:='T';
                  readln(ifile,inbuf);
                  GetTrack(inbuf+' ');
               end
            else if ((inbuf='CF')OR(inbuf='FF')) then
               begin
                  mode:='F';
                  readln(ifile,inbuf);
                  GetFill(inbuf+' ');
               end
            else if ((inbuf='CS')OR(inbuf='FS')) then
               begin
                  mode:='S';
                  readln(ifile,inbuf);
                  GetString(inbuf+' ');
               end
            else if ((inbuf='CV')OR(inbuf='FV')) then
               begin
                  mode:='V';
                  readln(ifile,inbuf);
                  GetVia(inbuf+' ');
               end
            else if (inbuf='COMP') then
               begin
                  GetComponent(iFile);
                  if(comp_hide_ref = 1) then add_apt(1,ref_des_width,ref_des_width);
                  if(comp_hide_comment = 1) then add_apt(1,comment_width,comment_width);
                  mode:='i';
                  New_Data:=False;
               end
            else
               begin
                  mode:='i';
                  New_Data:=False;
               end; {if else if}
            if (New_Data=True) then
            begin
//writeln(ofile,Mode,' x1=',x1,' y1=',y1,' x2=',x2,' y2=',y2);
//writeln(ofile,'Layer=',layer,' h=',cheight,' w=',cwidth,' lw=',linewidth);
//writeln(ofile,'dia=',diameter,' hs=',holesize,' pn=',padnum,' plane=',plane);
//writeln(ofile,'shape=',shape,' rot=',rotation,' fillx=',fillx,' filly=',filly);
//if (Mode='F') then writeln(ofile,'fill size ',fillx,' ',filly);
//writeln(ofile,'segments=',segments,' text=',ctext);
if (Mode='F') then
              begin
//              writeln(ofile,'add square ',fillx,',',filly);
              if(CheckBox1.Checked) then add_apt(2,fillx,filly);
              end else
if (Mode='V') then
              begin
//              writeln(ofile,'add square ',fillx,',',filly);
              add_apt(1,diameter,diameter);
              add_apt(1,diameter+spinedit1.Value,
                        diameter+spinedit1.value);     // solder mask enlargement
              add_apt(1,diameter+spinedit4.Value,
                        diameter+spinedit4.value);     // power plane enlargement
              NewData := False;
                 if(HoleSize>0)then
                    begin
                       for x:=low(drills) to high(drills) do
                          begin
                             if(drills[x][1] = HoleSize) then
                                begin
                                   Inc(drills[x][2]);
                                   NewData := True;
                                   break;
                                end;
                          end;
                       if(NewData = False)then
                          begin
                             Setlength(drills,high(drills)+2);
                             drills[high(drills)][1] := HoleSize;
                             drills[high(drills)][2] := 1;
                          end;
                    end;

              end else
if ((shape=-1)AND(linewidth>0)) then
              begin
//              writeln(ofile,'add round ',linewidth,',',linewidth);
              add_apt(1,linewidth,linewidth);
              end else
if (Mode='P') then
              begin
                 NewData := False;
                 if(HoleSize>0)then
                    begin
                       for x:=low(drills) to high(drills) do
                          begin
                             if(drills[x][1] = HoleSize) then
                                begin
                                   Inc(drills[x][2]);
                                   NewData := True;
                                   break;
                                end;
                          end;
                       if(NewData = False)then
                          begin
                             Setlength(drills,high(drills)+2);
                             drills[high(drills)][1] := HoleSize;
                             drills[high(drills)][2] := 1;
                          end;
                    end;
                 add_apt(shape,cwidth,cheight);      // add apeture
                 add_apt(shape,
                         cwidth+spinedit1.Value,
                         cheight+spinedit1.value);   // add solder mask apeture
                 add_apt(shape,
                         cwidth+spinedit3.Value,
                         cheight+spinedit3.value);   // add paste mask aperture

                 add_apt(shape,
                         cwidth+spinedit4.Value,
                         cheight+spinedit4.value);   // add power plane
                 if((plane = 2) OR (plane = 4)) then
                   add_apt(7,
                           cwidth,cheight);          // add thenmal

                 if(shape=4) then
                 begin
                   if(cwidth<cheight) then
                   add_apt(1,
                         cwidth+spinedit1.Value,
                         cwidth+spinedit1.value)
                   else
                   add_apt(1,
                         cheight+spinedit1.Value,
                         cheight+spinedit1.value);    // add solder mask apeture
                 end;                                 // add round if round rect

                 if((shape=2) AND (cwidth<>cheight))then
                 begin
                   if(cwidth<cheight) then
                   add_apt(2,
                         cwidth+spinedit1.Value,
                         cwidth+spinedit1.value)
                   else
                   add_apt(2,
                         cheight+spinedit1.Value,
                         cheight+spinedit1.value);
                 end;                                 // add square if rectangle


              end;
//writeln(ofile,'*******************');
            end;
         end;{while not eof}
         closefile(ifile);
// add drill guide aperture
        add_apt(1,
             spinedit2.Value,
             spinedit2.value);

x1:=10;
while(x1<next_dnum) do begin
                       write(ofile,'D',x1,chr(9));
           if (dnums[x1][1]=1) then write(ofile,'CIRCULAR   ');
           if (dnums[x1][1]=2) then write(ofile,'RECTANGULAR');
           if (dnums[x1][1]=3) then write(ofile,'OCTAGONAL  ');
           if (dnums[x1][1]=4) then write(ofile,'ROUNDRECT  ');
           if (dnums[x1][1]=5) then write(ofile,'CROSSHAIR  ');
           if (dnums[x1][1]=6) then write(ofile,'MOIRE      ');
           if (dnums[x1][1]=7) then write(ofile,'RELIEF     ');
                       write(ofile,chr(9),
                                        dnums[x1][2],
                                        chr(9),
                                        dnums[x1][3]);

                        if (dnums[x1][1]=1) then writeln(ofile,chr(9),0,chr(9),'MULTI')
                        else if( dnums[x1][2]=dnums[x1][3]) then writeln(ofile,chr(9),0,chr(9),'MULTI')
                        else writeln(ofile,chr(9),0,chr(9),'FLASH');

                       x1:=x1+1;
                       end;

     closefile(ofile);
// sort the tool table
     repeat
        new_data := False;
        for x:=low(drills) to high(drills)-1 do
           begin
              if(drills[x][1] > drills[x+1][1]) then
                 begin
                    y:=drills[x][1];
                    z:=drills[x][2];
                    drills[x][1]:=drills[x+1][1];
                    drills[x][2]:=drills[x+1][2];
                    drills[x+1][1]:=y;
                    drills[x+1][2]:=z;
                    New_data:=True;
                 end;
           end;
     until(new_Data = False);
     AssignFile(ofile,Unit6.BASE_File_Name+'.TOL');
     ReWrite(ofile);
     for x:=low(drills) to high(drills) do
        begin
           locs:=IntToStr(x+1);
           if(length(locs)<2) then locs:='0'+locs;
           write(ofile,'T'+locs+Chr(9));
           locs:=IntToStr(drills[x][1] div 1000);
           write(ofile,locs+'.');
           locs:=IntToStr(drills[x][1] MOD 1000);
           while(length(locs)<3) do locs:='0'+locs;
           write(ofile,locs+Chr(9));
           writeln(ofile,IntToStr(drills[x][2]));
        end;
     closefile(ofile);
     ofilename:=TempStr;     {save output file name}

     if(Form6Called = False) then
        begin
           GetWindowsDirectory(WindDir, Max_Path);
           inbuf := StrPas(WindDir)+'\NOTEPAD.EXE';
           If (Form1.Checkbox3.checked=True) then
             ShellExecute(Handle,'open',
             Pchar(inbuf),Pchar(ofilename),
             nil, SW_SHOWNORMAL);
        end;
   end;{if overwrite}
   showmessage('Done');
   Form3Completed := True;
   end;{fileopen=true}
end;   {procedure}

procedure TForm3.FormActivate(Sender: TObject);
var
locs    :String;
begin
   if(Form6Called) then
      begin

         Application.ProcessMessages;
         locs:='Set the desired spacing for mask and plane layers.'+#10+#13;
         locs:=locs+'Click of the "Make APT file" button.'+#10+#13;
         locs:=locs+'Select the PCB file to be plotted.'+#10+#13;
         locs:=locs+'Close this form when "done" is displayed.';
         Showmessage(locs);
      end;
end;

end.
